{hint: Pascal files location: ...\Lithuanian_CharSet_Converter\jni }
unit Lithuanian_CharSet_Converter_unit;

{$mode delphi}

interface

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes, SysUtils, AndroidWidget, stablayout, Laz_And_Controls, Spinner,
  selectdirectorydialog, opendialog, fileprovider, intentmanager, preferences,
  textfilemanager, fileutil, And_jni;
  
type

  { TAndroidModule1 }

  TAndroidModule1 = class(jForm)
    InputFileNameEdit: jEditText;
    ConvertSingleFileButton: jButton;
    AboutWebView: jWebView;
    OnlineVersionButton: jButton;
    jFileProvider1: jFileProvider;
    jIntentManager1: jIntentManager;
    jPreferences1: jPreferences;
    jTextFileManager1: jTextFileManager;
    RateAppButton: jButton;
    MoreAppsButton: jButton;
    ResultsMemo: jEditText;
    OutputMemo: jEditText;
    InputFileFormatLabel: jTextView;
    InputFileFormatComboBox: jSpinner;
    OutputFileFormatComboBox: jSpinner;
    OutputFileFormatLabel: jTextView;
    OpenInputFileButton: jButton;
    OpenOutputFileCheckBox: jCheckBox;
    OutputFileComboBox: jSpinner;
    OutpuFileAutoNameLabel: jTextView;
    OutputFileNameEdit: jEditText;
    jsTabLayout1: jsTabLayout;
    InputFileNameLabel: jTextView;
    OutputFileNameLabel: jTextView;
    procedure AndroidModule1ActivityResult(Sender: TObject;
      requestCode: integer; resultCode: TAndroidResult; intentData: jObject);
    procedure AndroidModule1Close(Sender: TObject);
    procedure AndroidModule1Create(Sender: TObject);
    procedure AndroidModule1JNIPrompt(Sender: TObject);
    procedure AndroidModule1RequestPermissionResult(Sender: TObject;
      requestCode: integer; manifestPermission: string;
      grantResult: TManifestPermissionResult);
    procedure ConvertSingleFileButtonClick(Sender: TObject);
    procedure InputFileFormatComboBoxItemSelected(Sender: TObject;
      itemCaption: string; itemIndex: integer);
    procedure jsTabLayout1TabSelected(Sender: TObject; position: integer;
      title: string);
    procedure MoreAppsButtonClick(Sender: TObject);
    procedure OnlineVersionButtonClick(Sender: TObject);
    procedure OpenInputFileButtonClick(Sender: TObject);
    procedure OpenOutputFileCheckBoxClick(Sender: TObject);
    procedure OutputFileComboBoxItemSelected(Sender: TObject;
      itemCaption: string; itemIndex: integer);
    procedure OutputFileFormatComboBoxItemSelected(Sender: TObject;
      itemCaption: string; itemIndex: integer);
    procedure RateAppButtonClick(Sender: TObject);
  private
    {private declarations}
  public
    {public declarations}
    procedure CheckIfFileIsUTF8BOM();
    procedure ConvertLithuanianFile();
    procedure GenerateOutputFilename(itemIndex: integer);

  end;

var
  AndroidModule1: TAndroidModule1;

    input_treeUri, output_treeUri: jObject;
    input_filename, output_filename: TFileName;
    input_file_size, output_file_size: int64;

    input_array_of_jbyte: TDynArrayOfJByte;
    output_array_of_jbyte: TDynArrayOfJByte;

    output_file_bytes: array of byte;

    number_of_bytes_to_show: integer;


    output_memory_stream: TMemoryStream;

    one_byte: byte;

    input_file_is_utf8_format: boolean;
    n: integer;

    input_file_data: array of byte;
    number_of_replaced_letters: int64;


    input_charset_select: integer;
    output_charset_select: integer;
    autofilenaming_charset_select: integer;
    open_file_after_conversion_select: boolean;
    eFormFiller_enabled: boolean;

    charset_statistics_of_input_file: array of int64;
    charset_probability_table: array[0..7] of int64;


    input_directory, old_input_directory, output_directory, old_output_directory,
    output_directory_short: TFileName;

    input_file_list: TStringList;
    input_file_formats_stringlist: TStringList;

    file_extensions_string, file_extensions_string_default: string;
    stop_conversion: boolean;

    input_directory_length, output_directory_length: integer;
    include_subdirectories: boolean;

    number_of_converted_files: integer;
    number_of_nulls: integer;

    tab_active_page: integer;
    about_html_stringlist: TStringList;

    app_store: Integer;


const OPEN_FILE = 111;
const SAVE_FILE = 222;


const GOOGLE_STORE = 1;
const SAMSUNG_STORE = 2;
const HUAWEI_STORE = 3;
const AMAZON_STORE = 4;

  //array size 8x18
   const
    LithuanianCharSetTable: array [0..143] of byte = (
    $41,$43,$45,$45,$49,$53,$55,$55,$5A,$61,$63,$65,$65,$69,$73,$75,$75,$7A, // ASCII
    $B5,$B6,$B7,$B8,$BD,$BE,$C6,$C7,$CF,$D0,$D1,$D2,$D3,$D4,$D5,$D6,$D7,$D8, // 772/774/775
    $8F,$80,$8B,$90,$AD,$9F,$A7,$A6,$92,$85,$87,$8A,$82,$8D,$9E,$97,$96,$91, // 770 (IBM Baltic)
    $DC,$DE,$F0,$F2,$F4,$F6,$F8,$FA,$FC,$DD,$DF,$F1,$F3,$F5,$F7,$F9,$FB,$FD, // 771/773/KBL
    $C0,$C8,$C6,$CB,$C1,$D0,$D8,$DB,$DE,$E0,$E8,$E6,$EB,$E1,$F0,$F8,$FB,$FE, // Windows-1257/Baltic-RIM/Latin-7/ISO-8859-13
    $A1,$C8,$CA,$CC,$C7,$A9,$D9,$DE,$AE,$B1,$E8,$EA,$EC,$E7,$B9,$F9,$FE,$BE, // Latin-4/ISO-8859-4/Latin-6/ISO-8859-10
    $C4,$C4,$C4,$C4,$C4,$C5,$C5,$C5,$C5,$C4,$C4,$C4,$C4,$C4,$C5,$C5,$C5,$C5, // UTF-8 first byte
    $84,$8C,$98,$96,$AE,$A0,$B2,$AA,$BD,$85,$8D,$99,$97,$AF,$A1,$B3,$AB,$BE); // UTF-8 second byte


implementation
  
{$R *.lfm}


procedure TAndroidModule1.jsTabLayout1TabSelected(Sender: TObject;
  position: integer; title: string);
begin


    tab_active_page := position;

    if position = 0 then
    begin
     AboutWebView.Visible := false;
     MoreAppsButton.Visible := false;
     RateAppButton.Visible := false;
     OnlineVersionButton.Visible := false;
     AboutWebView.Visible := false;

     InputFileNameLabel.Visible := true;
     InputFileNameEdit.Visible := true;
     OutputFileNameLabel.Visible := true;
     OutputFileNameEdit.Visible := true;
     OutpuFileAutoNameLabel.Visible := true;
     OutputFileComboBox.Visible := true;
//     OpenOutputFileCheckBox.Visible := true;
     OpenOutputFileCheckBox.Visible := false;

     OpenInputFileButton.Visible := true;
     ConvertSingleFileButton.Visible := true;
     InputFileFormatLabel.Visible := true;
     InputFileFormatComboBox.Visible := true;
     OutputFileFormatLabel.Visible := true;
     OutputFileFormatComboBox.Visible := true;
     OutputMemo.Visible := true;
     ResultsMemo.Visible := true;

     HideSoftInput(); //  hide virtual keyboard
    end
    else if position = 1 then
    begin
      AboutWebView.Visible := true;
      MoreAppsButton.Visible := true;
      RateAppButton.Visible := true;
      OnlineVersionButton.Visible := true;
      AboutWebView.Visible := true;

      InputFileNameLabel.Visible := false;
      InputFileNameEdit.Visible := false;
      OutputFileNameLabel.Visible := false;
      OutputFileNameEdit.Visible := false;
      OutpuFileAutoNameLabel.Visible := false;
      OutputFileComboBox.Visible := false;
      OpenOutputFileCheckBox.Visible := false;
      OpenInputFileButton.Visible := false;
      ConvertSingleFileButton.Visible := false;
      InputFileFormatLabel.Visible := false;
      InputFileFormatComboBox.Visible := false;
      OutputFileFormatLabel.Visible := false;
      OutputFileFormatComboBox.Visible := false;
      OutputMemo.Visible := false;
      ResultsMemo.Visible := false;
    end;



end;

procedure TAndroidModule1.MoreAppsButtonClick(Sender: TObject);
begin


      //jIntentManager1.SetAction(iaView);  //or 'android.intent.action.VIEW' // <<--- important to set

      if(app_store = GOOGLE_STORE) then
      begin
      //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://search?q=pname:'+'com.google.android.camera')); //works
      //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://dev?id=5448858571649033555')); // fails to work
      //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://developer?id=Cognaxon')); // fails to work
      jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/developer?id=Cognaxon')); //works
      end
      else if(app_store = SAMSUNG_STORE) then
      begin
      jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://cognaxon.com/index.php?page=download_educational'));
      end
      else if(app_store = HUAWEI_STORE) then
      begin
      jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://cognaxon.com/index.php?page=download_educational'));
      end
      else if(app_store = AMAZON_STORE) then
      begin
      jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://www.amazon.com/gp/mas/dl/android?s=Cognaxon')); //works
      end
      else
      begin
      jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://cognaxon.com/index.php?page=download_educational'));
      end;



      jIntentManager1.StartActivity();


end;

procedure TAndroidModule1.OnlineVersionButtonClick(Sender: TObject);
begin

      //jIntentManager1.SetAction(iaView);  //or 'android.intent.action.VIEW'
        jIntentManager1.SetDataUri(jIntentManager1.ParseUri('http://cognaxon.com/downloads/LithuanianCharSetConverter/online/Lithuanian_charset_converter.html'));
        jIntentManager1.StartActivity();

end;

procedure TAndroidModule1.OpenInputFileButtonClick(Sender: TObject);
begin

      //if IsRuntimePermissionGranted('android.permission.WRITE_EXTERNAL_STORAGE') then   //READ_EXTERNAL_STORAGE // if (targetSdkPlatform < 29)
      begin
        Self.RequestOpenFile(Self.GetEnvironmentDirectoryPath(dirDownloads), '*/*', OPEN_FILE);
      end;
{
      else
      begin


      //https://www.captechconsulting.com/blogs/runtime-permissions-best-practices-and-how-to-gracefully-handle-permission-removal
      if IsRuntimePermissionNeed() then   // that is, target API >= 23
      begin
         ShowMessage('Requesting Runtime Permission....');
         Self.RequestRuntimePermission('android.permission.WRITE_EXTERNAL_STORAGE', 5001);  //from AndroodManifest.xml
      end;

      end;
}

end;


procedure TAndroidModule1.OpenOutputFileCheckBoxClick(Sender: TObject);
begin

  open_file_after_conversion_select := OpenOutputFileCheckBox.Checked;

end;


procedure TAndroidModule1.OutputFileComboBoxItemSelected(Sender: TObject;
  itemCaption: string; itemIndex: integer);
begin

  GenerateOutputFilename(itemIndex);

end;

procedure TAndroidModule1.GenerateOutputFilename(itemIndex: integer);
var
  input_file_name: string;
  file_extension: string;
begin



      if (InputFileNameEdit.Text <> '') then
      begin

        case itemIndex of
          0: begin
          input_file_name := InputFileNameEdit.Text;
          file_extension := ExtractFileExt(InputFileNameEdit.Text);
          OutputFileNameEdit.Text := input_file_name.SubString(0, Length(InputFileNameEdit.Text) -  Length(file_extension)) + '_out' + file_extension;
             end;
          1: begin
          input_file_name := InputFileNameEdit.Text;
          file_extension := ExtractFileExt(InputFileNameEdit.Text);
          OutputFileNameEdit.Text := input_file_name.SubString(0, Length(InputFileNameEdit.Text) - Length(file_extension)) + '_out.txt';
             end;
          2: begin
          OutputFileNameEdit.Text := ChangeFileExt(InputFileNameEdit.Text, '.ffdata');
             end;
          3: begin
             end;
        end; // case itemIndex of



      end //if(InputFileNameEdit.Text <> '')
      else
      begin
        OutputFileNameEdit.Text := '';
      end;
      //========

      if (OutputFileComboBox.Items.Count = 3) then
      begin
        case itemIndex of
          0: begin
          if (output_charset_select = 7) then // UTF-8
          begin
            output_charset_select := 6;
          end;
          // UTF-8 BOM (byte order mark)
          end;

          1: begin
          if (output_charset_select = 7) then // UTF-8
          begin
            output_charset_select := 6;
          end;
          // UTF-8 BOM (byte order mark)
          end;


          2: begin
          output_charset_select := 7; // UTF-8
          end;


          end; // case itemIndex of
      end; //if (OutputFileComboBox.Items.Count = 3) then



      autofilenaming_charset_select := OutputFileComboBox.GetSelectedIndex();

      HideSoftInput(); //  hide virtual keyboard


end;

procedure TAndroidModule1.OutputFileFormatComboBoxItemSelected(Sender: TObject;
  itemCaption: string; itemIndex: integer);
begin


  output_charset_select := itemIndex;

end;

procedure TAndroidModule1.RateAppButtonClick(Sender: TObject);
begin



    //jIntentManager1.SetAction(iaView);  //or 'android.intent.action.VIEW' // <<--- important to set

    if(app_store = GOOGLE_STORE) then
    begin
    jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://details?id=com.cognaxon.lithuanian_charset_converter'));
    //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/details?id=com.cognaxon.lithuanian_charset_converter'));
    end
    else if(app_store = SAMSUNG_STORE) then
    begin
    jIntentManager1.SetDataUri(jIntentManager1.ParseUri('samsungapps://AppRating/com.cognaxon.lithuanian_charset_converter'));
    // jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://apps.samsung.com/appquery/AppRating.as?appId=com.cognaxon.lithuanian_charset_converter'));
    end
    else if(app_store = HUAWEI_STORE) then
    begin
    //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('appmarket://details?id=com.cognaxon.lithuanian_charset_converter'));
    jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://appgallery.cloud.huawei.com/appDetail?pkgName=com.cognaxon.lithuanian_charset_converter'));
    end
    else if(app_store = AMAZON_STORE) then
    begin
    //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('amzn://apps/android?p=com.cognaxon.lithuanian_charset_converter'));
    jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://www.amazon.com/gp/mas/dl/android?p=com.cognaxon.lithuanian_charset_converter'));
    end
    else
    begin
    jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/details?id=com.cognaxon.lithuanian_charset_converter'));
    end;



    jIntentManager1.StartActivity();


    //jIntentManager1.SetAction(iaView);  //or 'android.intent.action.VIEW'

    {
    try
      try
        //jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://search?q=pname:'+'com.google.android.camera')); //works
        jIntentManager1.SetDataUri(jIntentManager1.ParseUri('market://details?id=com.cognaxon.lithuanian_charset_converter'));
      except
      on E: Exception do
        jIntentManager1.SetDataUri(jIntentManager1.ParseUri('https://play.google.com/store/apps/details?id=com.cognaxon.lithuanian_charset_converter'));
      end;
    finally
      jIntentManager1.StartActivity();
    end;
    }



end;

procedure TAndroidModule1.AndroidModule1JNIPrompt(Sender: TObject);
var
  manifestPermissions: array of string;
begin


    //app_store := GOOGLE_STORE;
    //app_store := SAMSUNG_STORE;
    //app_store := HUAWEI_STORE;
    app_store := AMAZON_STORE;


   input_file_size := 0;
   output_file_size := 0;


   InputFileNameEdit.Clear();
   OutputFileNameEdit.Clear();


    //Self.jsTabLayout1.SetBackgroundToPrimaryColor();
    //Self.jsTabLayout1.SetElevation(20);
    Self.jsTabLayout1.SetSelectedTabIndicatorHeight(3);
    Self.jsTabLayout1.SetSelectedTabIndicatorColor(colbrLime);

//    Self.jsTabLayout1.AddTab('Single file');
    Self.jsTabLayout1.AddTab('Converter');
    Self.jsTabLayout1.AddTab('About');


     tab_active_page := 0;



     AboutWebView.Visible := false;
     MoreAppsButton.Visible := false;
     RateAppButton.Visible := false;
     OnlineVersionButton.Visible := false;
     AboutWebView.Visible := false;

     InputFileNameLabel.Visible := true;
     InputFileNameEdit.Visible := true;
     OutputFileNameLabel.Visible := true;
     OutputFileNameEdit.Visible := true;
     OutpuFileAutoNameLabel.Visible := true;
     OutputFileComboBox.Visible := true;
//     OpenOutputFileCheckBox.Visible := true;
     OpenOutputFileCheckBox.Visible := false;

     OpenInputFileButton.Visible := true;
     ConvertSingleFileButton.Visible := true;
     InputFileFormatLabel.Visible := true;
     InputFileFormatComboBox.Visible := true;
     OutputFileFormatLabel.Visible := true;
     OutputFileFormatComboBox.Visible := true;
     OutputMemo.Visible := true;
     ResultsMemo.Visible := true;



      file_extensions_string_default := 'txt;xml;c;h';


      input_directory := '';
      old_input_directory := '';
      output_directory := '';
      old_output_directory := '';

      file_extensions_string := '';
      stop_conversion := False;


      OutputMemo.Clear();
      ResultsMemo.Clear();




        input_charset_select := jPreferences1.GetIntData('input_charset_select', -1); // Autodetect Lithuanian charset
        output_charset_select := jPreferences1.GetIntData('output_charset_select', 6); // UTF-8 BOM
        autofilenaming_charset_select := jPreferences1.GetIntData('autofilenaming_charset_select', 0);
        open_file_after_conversion_select := jPreferences1.GetBoolData('open_file_after_conversion_select', False);

        file_extensions_string := jPreferences1.GetStringData('file_extensions', file_extensions_string_default);

        input_directory := jPreferences1.GetStringData('input_directory', '/');
        output_directory := jPreferences1.GetStringData('output_directory', '/');

        include_subdirectories := jPreferences1.GetBoolData('include_subdirectories', False);

        eFormFiller_enabled := jPreferences1.GetBoolData('eFormFiller', False);





//MMM      FileExtensionsEdit.Text := file_extensions_string;

//MMM      IncludeSubdirectoriesCheckBox.Checked := include_subdirectories;



      if (eFormFiller_enabled = True) then
      begin
        input_charset_select := 3;
      end;



      if (eFormFiller_enabled = True) then
      begin
        output_charset_select := 6;  // UTF-8 BOM
      end;



      input_file_is_utf8_format := False;


      if (eFormFiller_enabled = True) then
      begin
        OutputFileComboBox.Items.Add('filename + .ffdata (ABBYY eFormFiller format)');
        OutputFileComboBox.SetSelectedIndex(2);
      end
      else
      begin
        OutputFileComboBox.SetSelectedIndex(autofilenaming_charset_select);
      end;



//MMM      OutputFileComboBox.OnChange(Self);
//xxx OutputFileComboBox.OnItemSelected(Self, '', OutputFileComboBox.GetSelectedIndex()); //????
//xxx GenerateOutputFilename(OutputFileComboBox.GetSelectedIndex());

      OpenOutputFileCheckBox.Checked := open_file_after_conversion_select;


      InputFileFormatComboBox.SetSelectedIndex(input_charset_select);
      OutputFileFormatComboBox.SetSelectedIndex(output_charset_select);



      OutputFileNameEdit.Text := '';
      HideSoftInput(); //  hide virtual keyboard


      SetLength(charset_statistics_of_input_file, 256);




   about_html_stringlist := TStringList.Create();
   about_html_stringlist.Clear();

   about_html_stringlist.Clear();
   about_html_stringlist.Add('<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">');
   about_html_stringlist.Add('<html><head><meta content="text/html; charset=ISO-8859-1" http-equiv="content-type"><title>Lithuanian charset converter</title></head>');


   about_html_stringlist.Add('<body><big><b>Lithuanian charset converter v. ' + Self.GetVersionName() + ' (build: '+ IntToStr(Self.GetVersionCode()) + ')</b></big><br><br>');
   about_html_stringlist.Add('<br>');
   about_html_stringlist.Add('“Lithuanian charset converter” is free open-source cross-platform software made by Cognaxon<br>');
   about_html_stringlist.Add('<a href="http://cognaxon.com">http://cognaxon.com</a><br>');
   about_html_stringlist.Add('<br>');
   about_html_stringlist.Add('Before UTF-8 character encoding adoption, Lithuanians had used different character encodings which were incompatible between each other.<br>');
   about_html_stringlist.Add('“Lithuanian charset converter” converts between legacy character encodings and modern UTF-8.<br>');

   about_html_stringlist.Add('<br>');
   about_html_stringlist.Add('“Lithuanian charset converter” converts between:<br>');
   about_html_stringlist.Add('• ASCII;<br>');
   about_html_stringlist.Add('• 772/774/775;<br>');
   about_html_stringlist.Add('• 770 (IBM Baltic);<br>');
   about_html_stringlist.Add('• 771/773/KBL;<br>');
   about_html_stringlist.Add('• Windows-1257/Baltic-RIM/Latin-7/ISO-8859-13;<br>');
   about_html_stringlist.Add('• Latin-4/ISO-8859-4/Latin-6/ISO-8859-10;<br>');
   about_html_stringlist.Add('• UTF-8;<br>');
   about_html_stringlist.Add('• UTF-8 BOM.<br>');
   about_html_stringlist.Add('<br>');


   about_html_stringlist.Add('“Lithuanian charset converter” compiled for Android, compilation date: ' + {$include %date%} + ', time: ' + Format('%.*d',[2, {$include %timeHour%}]) + ':' + Format('%.*d',[2, {$include %timeMinute%}]) );
   about_html_stringlist.Add('</body></html>');


   AboutWebView.LoadFromHtmlString(about_html_stringlist.Text);


    // if (targetSdkPlatform < 29)
{
      if IsRuntimePermissionNeed() then   // that is, target API >= 23  - Android 6
     begin
        SetLength(manifestPermissions, 1);

        //hint: if you  get "write" permission then you have "read", too!
        manifestPermissions[0]:= 'android.permission.WRITE_EXTERNAL_STORAGE'; //from AndroodManifest.xml
        Self.RequestRuntimePermission(manifestPermissions, 6001);  // some/any value...

        SetLength(manifestPermissions, 0);
     end;
}


end;

procedure TAndroidModule1.AndroidModule1RequestPermissionResult(
  Sender: TObject; requestCode: integer; manifestPermission: string;
  grantResult: TManifestPermissionResult);
begin


  case requestCode of
   6001:begin
            if grantResult = PERMISSION_GRANTED  then
//              ShowMessage(manifestPermission + LineEnding + 'permission granted.' )
            else  //PERMISSION_DENIED

              // if (targetSdkPlatform < 29)
              //ShowMessage(manifestPermission + LineEnding + 'permission denied.' );
        end;
  end;

end;

procedure TAndroidModule1.AndroidModule1Close(Sender: TObject);
var
  ini_int_result: integer;
  ini_bool_result: boolean;
  ini_string_result: string;
begin


     input_charset_select := InputFileFormatComboBox.SelectedIndex - 1;
     output_charset_select := OutputFileFormatComboBox.SelectedIndex;




       ini_int_result := jPreferences1.GetIntData('input_charset_select', -1); // Autodetect Lithuanian charset
       if (input_charset_select <> ini_int_result) then
       begin
         jPreferences1.SetIntData('input_charset_select', input_charset_select);
       end;


       ini_int_result := jPreferences1.GetIntData('output_charset_select', 6); // UTF-8 BOM
       if (output_charset_select <> ini_int_result) then
       begin
         jPreferences1.SetIntData('output_charset_select', output_charset_select);
       end;


       ini_int_result := jPreferences1.GetIntData('autofilenaming_charset_select', 0);
       if (autofilenaming_charset_select <> ini_int_result) then
       begin
         jPreferences1.SetIntData('autofilenaming_charset_select', autofilenaming_charset_select);
       end;


       ini_bool_result := jPreferences1.GetBoolData('open_file_after_conversion_select', False);
       if (open_file_after_conversion_select <> ini_bool_result) then
       begin
         jPreferences1.SetBoolData('open_file_after_conversion_select', open_file_after_conversion_select);
       end;


       ini_string_result := jPreferences1.GetStringData('file_extensions', file_extensions_string_default);

//MMM       file_extensions_string := FileExtensionsEdit.Text;

       if (CompareStr(file_extensions_string, ini_string_result) <> 0) then
       begin
         jPreferences1.SetStringData('file_extensions', file_extensions_string);
       end;



//MMM       include_subdirectories := IncludeSubdirectoriesCheckBox.Checked;
       ini_bool_result := jPreferences1.GetBoolData('include_subdirectories', False);
       if (include_subdirectories <> ini_bool_result) then
       begin
         jPreferences1.SetBoolData('include_subdirectories', include_subdirectories);
       end;


       //  ini_bool_result := ProgramIniFile.ReadBool( 'LithuanianCharSetConverter', 'eFormFiller', false);
       //  if(eFormFiller_enabled <> ini_bool_result) then
       //  begin
       //  ProgramIniFile.WriteBool( 'LithuanianCharSetConverter', 'eFormFiller', eFormFiller_enabled);
       //  end;




     SetLength(charset_statistics_of_input_file, 0);


end;

procedure TAndroidModule1.AndroidModule1ActivityResult(Sender: TObject;
  requestCode: integer; resultCode: TAndroidResult; intentData: jObject);
var
  temp_char_string: array of Byte;
  output_array_of_jbyte_size: int64;
begin



    if resultCode = RESULT_OK then
    begin

      if intentData = nil then
      begin
        ShowMessage('Error: intentData nil received.');
        Exit;
      end;





      if requestCode = OPEN_FILE then
      begin

        input_treeUri := jIntentManager1.GetDataUri(intentData);

        if input_treeUri = nil then
        begin
          ShowMessage('Error: Uri nil received.');
          Exit;
        end;

        input_filename := GetFileNameByUri(input_treeUri);
        InputFileNameEdit.Text := input_filename;
        GenerateOutputFilename(OutputFileComboBox.GetSelectedIndex());

        SetLength(input_array_of_jbyte, 0);

        //load bytes from Uri
        input_array_of_jbyte := LoadBytesFromUri(input_treeUri);
        input_file_size := Length(input_array_of_jbyte);

//        SetLength(input_file_data, input_file_size);

//        for n := 0 to input_file_size - 1 do
//          input_file_data[n] := byte(input_array_of_jbyte[n]);

        //CheckIfFileIsUTF8BOM();

      end; // if requestCode = OPEN_FILE



      if requestCode = SAVE_FILE then
      begin

        output_treeUri := jIntentManager1.GetDataUri(intentData);

        if output_treeUri = nil then
        begin
          ShowMessage('Error: Uri nil received.');
          Exit;
        end;

        Self.SaveBytesToUri(output_array_of_jbyte, output_treeUri); // save bytes to file

        if (tab_active_page = 0) then
        begin
          if (output_charset_select >= 6) then // UTF-8 BOM
          begin
           OutputMemo.Text := '';

           output_array_of_jbyte_size := Length(output_array_of_jbyte);
           SetLength(temp_char_string, output_array_of_jbyte_size + 1);

           for n := 0 to output_array_of_jbyte_size - 1 do
             temp_char_string[n] := byte(output_array_of_jbyte[n]);

           temp_char_string[output_array_of_jbyte_size] := $00;
           OutputMemo.Text := Copy(String(temp_char_string), 1, output_array_of_jbyte_size);
          end; // if (output_charset_select >= 6) // UTF-8 BOM

        end; // if (tab_active_page = 0) then

      end; // if requestCode = SAVE_FILE




    end; // if resultCode = RESULT_OK



end;



procedure TAndroidModule1.AndroidModule1Create(Sender: TObject);
begin



  OutputMemo.InputTypeEx := itxMultiLine;
  OutputMemo.MaxTextLength := 10000000;
  OutputMemo.ScrollBarStyle := scrlInsideInset;
  OutputMemo.MaxLines := 1000000;
  OutputMemo.HorScrollBar := False;
  OutputMemo.VerScrollBar := True;
  OutputMemo.WrappingLine := True;
  OutputMemo.Enabled := False;
  OutputMemo.Editable := False;

  ResultsMemo.InputTypeEx := itxMultiLine;
  ResultsMemo.MaxTextLength := 10000;
  ResultsMemo.ScrollBarStyle := scrlInsideInset;
  ResultsMemo.MaxLines := 128;
  ResultsMemo.HorScrollBar := False;
  ResultsMemo.VerScrollBar := True;
  ResultsMemo.WrappingLine := True;
  ResultsMemo.Enabled := False;
  ResultsMemo.Editable := False;



  InputFileFormatComboBox.Items.Clear();
  InputFileFormatComboBox.Items.Add('Autodetect Lithuanian charset');  // index starts from 0
  InputFileFormatComboBox.Items.Add('ASCII');
  InputFileFormatComboBox.Items.Add('772 / Lithuanian Standard LST 1284:1993 (Lithuanian and Russian characters) ; 774 / Lithuanian Standard LST 1283:1993 (Lithuanian and English characters) ; 775 (Microsoft)');
  InputFileFormatComboBox.Items.Add('770 / IBM Baltic / Lithuanian Standard RST 1095-89');
  InputFileFormatComboBox.Items.Add('771 / KBL / Baltic Amadeus (Lithuanian and Russian characters) ; 773 Lithuanian (mix of 771 and 775)');
  InputFileFormatComboBox.Items.Add('Windows-1257 / IBM Baltic RIM ; Latin-7 / ISO-8859-13');
  InputFileFormatComboBox.Items.Add('Latin-4 / ISO-8859-4 ; Latin-6 / ISO-8859-10');
  InputFileFormatComboBox.Items.Add('UTF-8 BOM (byte order mark)');
  InputFileFormatComboBox.Items.Add('UTF-8');


  OutputFileFormatComboBox.Items.Clear();
  OutputFileFormatComboBox.Items.Add('ASCII');
  OutputFileFormatComboBox.Items.Add('772 / Lithuanian Standard LST 1284:1993 (Lithuanian and Russian characters) ; 774 / Lithuanian Standard LST 1283:1993 (Lithuanian and English characters) ; 775 (Microsoft)');
  OutputFileFormatComboBox.Items.Add('770 / IBM Baltic / Lithuanian Standard RST 1095-89');
  OutputFileFormatComboBox.Items.Add('771 / KBL / Baltic Amadeus (Lithuanian and Russian characters) ; 773 Lithuanian (mix of 771 and 775)');
  OutputFileFormatComboBox.Items.Add('Windows-1257 / IBM Baltic RIM ; Latin-7 / ISO-8859-13');
  OutputFileFormatComboBox.Items.Add('Latin-4 / ISO-8859-4 ; Latin-6 / ISO-8859-10');
  OutputFileFormatComboBox.Items.Add('UTF-8 BOM (byte order mark)');
  OutputFileFormatComboBox.Items.Add('UTF-8');

  OutputFileComboBox.Items.Clear();
  OutputFileComboBox.Items.Add('filename + _out + original file extention');
  OutputFileComboBox.Items.Add('filename + _out.txt');


end;

procedure TAndroidModule1.ConvertSingleFileButtonClick(Sender: TObject);
begin


     if (input_file_size = 0) then
     begin
       ShowMessage('Input filesize is 0.Please select another input file.');
       Exit;
     end;



     ConvertSingleFileButton.Enabled := False;
     OpenInputFileButton.Enabled := False;


     ConvertLithuanianFile();


     ConvertSingleFileButton.Enabled := True;
     OpenInputFileButton.Enabled := True;


     if (input_charset_select = output_charset_select) then
     begin
       ResultsMemo.AppendLn('Input and output charsets are the same. Conversion skipped.');
//MMM       ResultsMemo.SelStart := 0;
//MMM       ResultsMemo.SetFocus(); // needed to invoke scrolling to the top
       OpenInputFileButton.SetFocus();
       HideSoftInput(); //  hide virtual keyboard
       Exit;
     end;


     if (number_of_replaced_letters = 0) then
     begin
       //ShowMessage('Warning: input charset was not detected in input file.');
     end
     else
     begin
       if ((input_charset_select <> 4) and (output_charset_select > 5)) then
       begin
         ResultsMemo.AppendLn('Conversion completed.' + LineEnding + 'Number of replaced letters: ' + IntToStr(number_of_replaced_letters div 2));
       end
       else
       begin
         ResultsMemo.AppendLn('Conversion completed.' + LineEnding + 'Number of replaced letters: ' + IntToStr(number_of_replaced_letters));
       end;
     end;

//MMM     ResultsMemo.SelStart := 0;
//MMM     ResultsMemo.SetFocus(); // needed to invoke scrolling to the top
     OpenInputFileButton.SetFocus();


//   if (open_file_after_conversion_select = True) then
     if (OpenOutputFileCheckBox.Checked = True) then
     begin
//MMM       OpenDocument(OutputFileNameEdit.Text);

       {
       ShowMessage('jIntentManager1.StartActivity()');

       jIntentManager1.SetDataAndType('file://' + OutputFileNameEdit.Text, 'text/html');
//     jIntentManager1.SetDataAndType('file://' + environmentDirectoryPath + '/' + fileToPrint, 'text/html');
//       jIntentManager1.SetDataAndType('file://' + Self.GetEnvironmentDirectoryPath(dirDownloads) + PathDelim + OutputFileNameEdit.Text, 'text/html');
       jIntentManager1.StartActivity();

       //if jIntentManager1.IsCallable(jIntentManager1.GetIntent()) then
       //   jIntentManager1.StartActivity()
       //else
       //   ShowMessage('No Activity found which could open file' + LineEnding + OutputFileNameEdit.Text);
           }
     end; //if (OpenOutputFileCheckBox.Checked = True) then





end;

procedure TAndroidModule1.InputFileFormatComboBoxItemSelected(Sender: TObject;
  itemCaption: string; itemIndex: integer);
begin

  input_charset_select := itemIndex - 1;

end;



procedure TAndroidModule1.CheckIfFileIsUTF8BOM();
begin


  if (input_file_size = 0) then
    exit;


  //if(((int)input_file_data[0] = $EF)&((int)input_file_data[1] = $BB)&((int)input_file_data[2] = $BF)) then // UTF-8 BOM (byte order mark)
  if ((input_file_data[0] = 239) and (input_file_data[1] = 187) and
    (input_file_data[2] = 191)) then  // UTF-8 BOM (byte order mark)
  begin
    input_file_is_utf8_format := True;
    input_charset_select := 6; // UTF-8 BOM (byte order mark)
  end
  else
  begin
    input_file_is_utf8_format := False;
  end;


end;


procedure TAndroidModule1.ConvertLithuanianFile();
var
  i, i2, i3: integer;
  current_value: byte;
  table_value, table_value2: byte;
  current_byte, current_byte2, current_byte3: byte;
  icharset: integer;

  charset_n: integer;
  number_of_charset_letters: integer;

  autodetected_charset: integer;
  max_char_count: int64;
  start_i: int64;

begin

  number_of_replaced_letters := 0;
  number_of_nulls := 0;

  if (tab_active_page = 0) then
  begin
   OutputMemo.Clear();
   ResultsMemo.Clear();
  end;


  input_charset_select := InputFileFormatComboBox.SelectedIndex - 1;
  output_charset_select := OutputFileFormatComboBox.SelectedIndex;

  autodetected_charset := 0;
  max_char_count := 0;


  SetLength(input_file_data, input_file_size);

  for n := 0 to input_file_size - 1 do
    input_file_data[n] := byte(input_array_of_jbyte[n]);


  //=========================
  if (input_charset_select = -1) then // Autodetect Lithuanian charset
  begin
    //if(((int)input_file_data[0] = $EF) and ((int)input_file_data[1] = $BB) and ((int)input_file_data[2] = $BF)) then // UTF-8 BOM (byte order mark)
    if ((input_file_data[0] = 239) and (input_file_data[1] = 187) and (input_file_data[2] = 191)) then   // UTF-8 BOM (byte order mark)
    begin
      autodetected_charset := 6; // UTF-8 BOM (byte order mark)
    end
    else
    begin
      // not UTF-8 BOM (byte order mark) BEGIN
      for i := 0 to 8 - 1 do
      begin
        charset_probability_table[i] := 0;
      end;

      for i := 0 to 256 - 1 do
      begin
        charset_statistics_of_input_file[i] := 0;
      end;
      //======================

      // Count number of Lithuanian UTF-8 characters
      for i := 0 to input_file_size - 2 do
      begin
        current_byte := integer(input_file_data[i]);
        current_byte2 := integer(input_file_data[i + 1]);

        //-----------
        if (current_byte = 0) then
        begin
          Inc(number_of_nulls);
        end
        else if (current_byte > 127) then
        begin

          for icharset := 0 to 18 - 1 do
          begin
            table_value := LithuanianCharSetTable[icharset + 108]; // UTF-8 first byte
            table_value2 := LithuanianCharSetTable[icharset + 126]; // UTF-8 second byte
            if ((table_value = current_byte) and (table_value2 = current_byte2)) then
            begin
              Inc(charset_probability_table[7]); // UTF-8
              break;
            end; //if ((table_value = current_byte) and (table_value2 = current_byte2)) then
          end; // for icharset := 0 to 18 - 1 do
        end;
        //else if(current_byte > 127)
        //-----------

      end; // for i := 0 to input_file_size - 2 do
      //======================

      for i := 0 to input_file_size - 1 do
      begin
        current_byte := input_file_data[i];
        Inc(charset_statistics_of_input_file[current_byte]);
      end; //for i := 0 to input_file_size - 1 do

      for i := 128 to 256 - 1 do
      begin
        number_of_charset_letters := charset_statistics_of_input_file[i];

        for charset_n := 0 to 6 - 1 do
        begin

          for icharset := 0 to 18 - 1 do
          begin
            table_value := LithuanianCharSetTable[icharset + (18 * charset_n)];///crash

            if (table_value = i) then
            begin
              charset_probability_table[charset_n] :=
                charset_probability_table[charset_n] + number_of_charset_letters;
              break;
            end;

          end; // for icharset := 0 to 18 - 1 do
        end; // for charset_n := 0 to 6 - 1 do

      end; //for i := 128 to 256 - 1 do



      for i := 0 to 8 - 1 do
      begin
        if (max_char_count < charset_probability_table[i]) then
        begin
          max_char_count := charset_probability_table[i];
          autodetected_charset := i;
        end;
        //if (autodetected_charset < charset_probability_table[i])

      end; //for i := 0 to 8 - 1 do

    end; // not UTF-8 BOM (byte order mark) END



    input_charset_select := autodetected_charset;
    //InputFileFormatComboBoxChange(Self);

    //if (LithuanianCharsetPageControl.ActivePage = TabSheetBatchConvert) then
    //begin

    if (input_charset_select = output_charset_select) then
    begin
      SetLength(output_array_of_jbyte, input_file_size);

      for n := 0 to input_file_size - 1 do
        output_array_of_jbyte[n] := input_array_of_jbyte[n];

      Exit;
    end;

    //end; //if (LithuanianCharsetPageControl.ActivePage = TabSheetBatchConvert) then


    if (tab_active_page = 0) then
    begin
      ResultsMemo.AppendLn('Autodetected charset: ' + InputFileFormatComboBox.Items.Strings[autodetected_charset + 1]);
    end;

  end; // if (input_charset_select = -1) then // Autodetect Lithuanian charset
  //=========================




  current_value := 0;
  icharset := 0;
  table_value := 0;
  table_value2 := 0;
  i := 0;
  i2 := 0;
  i3 := 0;
  n := 0;



  if ((input_charset_select > 5) and (output_charset_select < 6)) then // input UTF-8 and output not UTF-8
  begin

//    if FileExists(output_filename_string) then
//      DeleteFile(output_filename_string);

    try
      output_memory_stream := TMemoryStream.Create();

      try
        //======================
        start_i := 0; //if((input_charset_select = 7)

        if (input_charset_select = 6) then
        begin
          start_i := 3;
        end;


        // Count number of Lithuanian UTF-8 characters
        for i := start_i to input_file_size - 1 do
        begin

          current_byte := input_file_data[i];

          i2 := i + 1;
          if(i2 < input_file_size) then
          current_byte2 := input_file_data[i2]
          else
          current_byte2 := 0;

          i3 := i + 2;
          if(i3 < input_file_size) then
          current_byte3 := input_file_data[i3]
          else
          current_byte3 := 0;

          //-----------
          if (current_byte = 0) then
          begin
            Inc(number_of_nulls);
          end
          else if (current_byte > 127) then
          begin


            if ((current_byte = $E2) and (current_byte2 = $80)) then
            begin

            if (current_byte3 = $90) then  // Hyphen
            begin
              current_value := $2D;
              output_memory_stream.WriteBuffer(current_value, 1);
            end

            else if (current_byte3 = $91) then // Non-Breaking Hyphen
            begin
              current_value := $2D;
              output_memory_stream.WriteBuffer(current_value, 1);
            end

            else if (current_byte3 = $92) then // Figure Dash
            begin
              current_value := $2D;
              output_memory_stream.WriteBuffer(current_value, 1);
            end

            else if (current_byte3 = $93) then // En Dash
            begin
              current_value := $2D;
              output_memory_stream.WriteBuffer(current_value, 1);
            end

            else if (current_byte3 = $94) then // Em Dash
            begin
              current_value := $2D;
              output_memory_stream.WriteBuffer(current_value, 1);
            end

            else if (current_byte3 = $95) then // Horizontal Bar
            begin
              current_value := $2D;
              output_memory_stream.WriteBuffer(current_value, 1);
            end

            end // if(current_byte = $E2) and (current_byte2 = $80) then


            else if (current_byte = $EF) then
            begin

            if ((current_byte2 = $B9) and (current_byte3 = $98)) then  // Small Em Dash
            begin
              current_value := $2D;
              output_memory_stream.WriteBuffer(current_value, 1);
            end

            else if ((current_byte2 = $B9) and (current_byte3 = $A3)) then // Small Hyphen-Minus
            begin
              current_value := $2D;
              output_memory_stream.WriteBuffer(current_value, 1);
            end

            else if ((current_byte2 = $BC) and (current_byte3 = $8D)) then // Fullwidth Hyphen-Minus
            begin
              current_value := $2D;
              output_memory_stream.WriteBuffer(current_value, 1);
            end

            end // if (current_byte = $EF) then

            else // not hyphen
            begin

            for icharset := 0 to 18 - 1 do
            begin
              table_value := LithuanianCharSetTable[icharset + 108]; // UTF-8 first byte
              table_value2 := LithuanianCharSetTable[icharset + 126];
              // UTF-8 second byte
              if ((table_value = current_byte) and (table_value2 = current_byte2)) then
              begin
                current_value := LithuanianCharSetTable[icharset +  (18 * output_charset_select)];

                if (current_value = 0) then
                begin
                  //remove null characters from file
                end
                else
                begin
                  output_memory_stream.WriteBuffer(current_value, 1);
                end;

                Inc(number_of_replaced_letters);
                break;

              end; //if ((table_value = current_byte) and (table_value2 = current_byte2)) then
            end; //for icharset := 0 to 18 - 1 do

            end // else not hyphen

          end //else if(current_byte > 127)
          else
          begin
            output_memory_stream.WriteBuffer(input_file_data[i], 1);
          end;
          //-----------

        end;//for i := start_i to input_file_size - 2 do


               output_file_size := output_memory_stream.Size;
               SetLength(output_array_of_jbyte, output_file_size);

               output_memory_stream.Position := 0;

               for i:=0 to output_file_size-1 do
               output_array_of_jbyte[i] := JByte(output_memory_stream.ReadByte());

      finally
        output_memory_stream.Free;
      end;
    except
      ShowMessage('Error: Unable to create memory stream.');
    end;

  end //if((input_charset_select := 7) and (output_charset_select < 6))  // input UTF-8 and output not UTF-8
  //======================
  else if ((input_charset_select < 6) and (output_charset_select < 6)) then // if not UTF-8
  begin

    for i := 0 to input_file_size - 1 do
    begin
      current_value := input_file_data[i];

      if (current_value = 0) then
      begin
        //remove null characters from file
      end
      else if (current_value > 127) then
      begin
        for icharset := 0 to 18 - 1 do
        begin
          table_value := LithuanianCharSetTable[icharset + (18 * input_charset_select)];
          if (table_value = current_value) then
          begin
            input_file_data[i] :=
              LithuanianCharSetTable[icharset + (18 * output_charset_select)];
            Inc(number_of_replaced_letters);
            break;
          end;
          //if (table_value := value)
        end;

      end;
      //else if(value > 127)

    end; // for i := 0 to input_file_size - 1 do


    try
        output_memory_stream := TMemoryStream.Create();
      try
        output_memory_stream.WriteBuffer(Pointer(input_file_data)^, Length(input_file_data));


        output_file_size := output_memory_stream.Size;
        SetLength(output_array_of_jbyte, output_file_size);

        output_memory_stream.Position := 0;

        for i:=0 to output_file_size-1 do
        output_array_of_jbyte[i] := JByte(output_memory_stream.ReadByte());


      finally
        output_memory_stream.Free;
      end;
    except
      ShowMessage('Error: Unable to create memory stream.');
    end;

  end//if (output_charset_select <> 6) // if not UTF-8
  else if ((output_charset_select = 6) or (output_charset_select = 7)) then // UTF-8
  begin
    //===============
    if ((input_charset_select = 6) and (output_charset_select = 7)) then
    begin

      try
        output_memory_stream := TMemoryStream.Create();
        try
          for i := 3 to input_file_size - 1 do
          begin
            current_value := input_file_data[i];

            if (current_value = 0) then
            begin
              //remove null characters from file
            end
            else
            begin
              //output_memory_stream.WriteBuffer(input_file_data[i], 1);
              output_memory_stream.WriteBuffer(current_value, 1);
            end;

          end; //for i := 3 to input_file_size - 1 do


          output_file_size := output_memory_stream.Size;
          SetLength(output_array_of_jbyte, output_file_size);

          output_memory_stream.Position := 0;

          for i:=0 to output_file_size-1 do
          output_array_of_jbyte[i] := JByte(output_memory_stream.ReadByte());

        finally
          output_memory_stream.Free;
        end;
      except
        ShowMessage('Error: Unable to create memory stream.');
      end;

    end //if((input_charset_select = 6) and (output_charset_select = 7)) then

    else if ((input_charset_select = 7) and (output_charset_select = 6)) then
    begin

      try
        output_memory_stream := TMemoryStream.Create();
        try

          one_byte := 239;
          output_memory_stream.WriteBuffer(one_byte, 1);
          one_byte := 187;
          output_memory_stream.WriteBuffer(one_byte, 1);
          one_byte := 191;
          output_memory_stream.WriteBuffer(one_byte, 1);


          for i := 0 to input_file_size - 1 do
          begin
            current_value := input_file_data[i];

            if (current_value = 0) then
            begin
              //remove null characters from file
            end
            else
            begin
              //output_memory_stream.WriteBuffer(input_file_data[i], 1);
              output_memory_stream.WriteBuffer(current_value, 1);
            end;

          end; //for i := 0 to input_file_size-1 do


          output_file_size := output_memory_stream.Size;
          SetLength(output_array_of_jbyte, output_file_size);

          output_memory_stream.Position := 0;

          for i:=0 to output_file_size-1 do
          output_array_of_jbyte[i] := JByte(output_memory_stream.ReadByte());

        finally
          output_memory_stream.Free;
        end;
      except
        ShowMessage('Error: Unable to create memory stream.');
      end;

    end //===============
    else // non-UTF-8 into UTF-8
    begin

      if (input_charset_select <> 4) then // if not Latin-7/ISO-8859-13/Baltic-RIM/ANSI-1257 charset
      begin

        for i := 0 to input_file_size - 1 do
        begin
          current_value := input_file_data[i];

          if (current_value = 0) then
          begin
            //remove null characters from file
          end
          else if (current_value > 127) then
          begin

            for icharset := 0 to 18 - 1 do
            begin
              table_value := LithuanianCharSetTable[icharset + (18 * input_charset_select)];
              if (table_value = current_value) then
              begin
                //ShowMessage('original := ' + IntToStr((int)input_file_data[i]), mtInformation, [mbOK], LithuanianConverterForm);
                input_file_data[i] := LithuanianCharSetTable[icharset + (18 * 4)];
                //convert into Windows-1257 charset
                Inc(number_of_replaced_letters);
                //ShowMessage('replaced to := ' + IntToStr((int)input_file_data[i]), mtInformation, [mbOK], LithuanianConverterForm);
                //break;
              end; // if (table_value = current_value) then
            end; // for icharset := 0 to 18 - 1 do

          end;
          //else if(value > 127)

        end; // for i := 0 to input_file_size - 1 do


        //if(number_of_replaced_letters = 0)
        //begin

        //ShowMessage('Step #1. Warning: input charset was not detected in input file.', mtInformation, [mbOK], LithuanianConverterForm);
        //end;

        //else
        //begin
        //ShowMessage('Step #1. Conversion completed. Number of replaced letters: ' + IntToStr(number_of_replaced_letters), mtInformation, [mbOK], LithuanianConverterForm);
      end;  //  if (input_charset_select <> 4) then // if not Latin-7/ISO-8859-13/Baltic-RIM/ANSI-1257 charset


    try

      output_memory_stream := TMemoryStream.Create();
      try
        //   if((output_charset_select = 6) and (OutputFileComboBox.ItemIndex <> 2)) // if UTF-8 BOM  and not ABBYY eFormFiller format
        if (output_charset_select = 6) then // if UTF-8 BOM
        begin
          one_byte := 239;
          output_memory_stream.WriteBuffer(one_byte, 1);
          one_byte := 187;
          output_memory_stream.WriteBuffer(one_byte, 1);
          one_byte := 191;
          output_memory_stream.WriteBuffer(one_byte, 1);
        end;

        for i := 0 to input_file_size - 1 do
        begin
          current_value := input_file_data[i];

          if (current_value = 0) then
          begin
            //remove null characters from file
          end
          else if (current_value < 128) then
          begin
            output_memory_stream.WriteBuffer(input_file_data[i], 1);
          end
          else if (current_value = 192) then
          begin
            one_byte := $C4;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $84;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 193) then
          begin
            one_byte := $C4;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $AE;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 198) then
          begin
            one_byte := $C4;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $98;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 200) then
          begin
            one_byte := $C4;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $8C;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 203) then
          begin
            one_byte := $C4;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $96;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 208) then
          begin
            one_byte := $C5;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $A0;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 216) then
          begin
            one_byte := $C5;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $B2;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 219) then
          begin
            one_byte := $C5;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $AA;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 222) then
          begin
            one_byte := $C5;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $BD;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 224) then
          begin
            one_byte := $C4;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $85;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 225) then
          begin
            one_byte := $C4;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $AF;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 230) then
          begin
            one_byte := $C4;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $99;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 232) then
          begin
            one_byte := $C4;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $8D;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 235) then
          begin
            one_byte := $C4;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $97;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 240) then
          begin
            one_byte := $C5;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $A1;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 248) then
          begin
            one_byte := $C5;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $B3;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 251) then
          begin
            one_byte := $C5;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $AB;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else if (current_value = 254) then
          begin
            one_byte := $C5;
            output_memory_stream.WriteBuffer(one_byte, 1);
            one_byte := $BE;
            output_memory_stream.WriteBuffer(one_byte, 1);
            Inc(number_of_replaced_letters);
          end
          else
          begin
            //output_memory_stream.WriteBuffer(one_byte, 1); // remove non-lithuanian characters
          end;

        end; //for i := 0 to input_file_size-1 do


        output_file_size := output_memory_stream.Size;
        SetLength(output_array_of_jbyte, output_file_size);

        output_memory_stream.Position := 0;

        for i:=0 to output_file_size-1 do
        output_array_of_jbyte[i] := JByte(output_memory_stream.ReadByte());

      finally
        output_memory_stream.Free;
      end;
    except
      ShowMessage('Error: Unable to create memory stream.');
    end;

    end; // else // non-UTF-8 into UTF-8



  end;//if ((output_charset_select = 6) or (output_charset_select = 7)) // UTF-8


  Self.RequestCreateFile(Self.GetEnvironmentDirectoryPath(dirDownloads), '*/*', OutputFileNameEdit.Text, SAVE_FILE);




end;


end.
